#include <string.h>  
#include <windows.h>  
#include <sql.h>  
#include <sqlext.h>  
#include <odbcss.h>  
#include <cstdlib>
#include <iostream>

#define MAXBUFLEN 255
// SQLProcedureColumns constants
#define COLUMN_NAME				4
#define COLUMN_TYPE				5
#define DATA_TYPE				6
#define BUFFER_LENGTH			9
#define ORDINAL_POSITION		18

const SQLTCHAR* mySQL_DSN  = L"mySQLuni";
void GetInfo ();

int main()
	{
	GetInfo ();
	return 0;
	}

void GetInfo ()
	{
	// Allocate an environment handle
	SQLHENV hEnv = NULL;
	if (SQL_SUCCEEDED (SQLAllocHandle (SQL_HANDLE_ENV, SQL_NULL_HANDLE, &hEnv)))
		{
		SQLINTEGER nVer = SQL_OV_ODBC3;
		if (SQL_SUCCEEDED (SQLSetEnvAttr (hEnv, SQL_ATTR_ODBC_VERSION, (SQLPOINTER)nVer, 0)))
			{
			// Allocate a connection handle
			SQLHDBC hDbc = NULL;
			if (SQL_SUCCEEDED (SQLAllocHandle (SQL_HANDLE_DBC, hEnv, &hDbc)))
				{
				// Set connect timeout
				SQLSetConnectOption (hDbc, SQL_LOGIN_TIMEOUT, 10);

				if (SQL_SUCCEEDED (SQLConnect (hDbc, const_cast<SQLTCHAR*>(mySQL_DSN), SQL_NTS, NULL, 0, NULL, 0)))
					{
					SQLUSMALLINT supported = 0;

					if (SQL_SUCCEEDED (SQLGetFunctions (hDbc, SQL_API_SQLPROCEDURECOLUMNS, &supported)))
						{
						if (supported == SQL_TRUE)
							{
							std::wcout << L"SQLPROCEDURECOLUMNS IS supported" << std::endl;
							}
						else
							{
							std::wcout << L"SQLPROCEDURECOLUMNS IS NOT supported" << std::endl;
							}
						}

					// see how many columns we get
					SQLHSTMT hStmt = NULL;
					SQLTCHAR* lpszStoredProcedure = L"params178";
					if (SQL_SUCCEEDED (SQLAllocHandle (SQL_HANDLE_STMT, hDbc, &hStmt)))
						{
						// Get all stored procedure columns
						if (SQL_SUCCEEDED (SQLProcedureColumns (hStmt, NULL, 0, NULL, 0, lpszStoredProcedure, SQL_NTS, NULL, 0)))
							{
							int count (0);

							SQLTCHAR szParameterName[256];
							SQLSMALLINT nParameterType = 0;
							SQLSMALLINT nParameterDataType = 0;
							SQLINTEGER nLen = 0;

							// Bind data for fetch (parameter name, type (input, input/output, output), data type)
							if ((SQL_SUCCEEDED (SQLBindCol (hStmt, COLUMN_NAME, SQL_C_TCHAR, szParameterName, sizeof (szParameterName), &nLen))) &&
								(SQL_SUCCEEDED (SQLBindCol (hStmt, COLUMN_TYPE, SQL_SMALLINT, &nParameterType, sizeof (nParameterType), &nLen))) &&
								(SQL_SUCCEEDED (SQLBindCol (hStmt, DATA_TYPE, SQL_SMALLINT, &nParameterDataType, sizeof (nParameterDataType), &nLen))))
								{

								while (TRUE)
									{
									// Fetch data
									SQLRETURN  rc = SQLFetch (hStmt);
									if (!SQL_SUCCEEDED (rc))
										{
										if (rc == SQL_NO_DATA)
											{
											std::wcout << L"SQLFetch returned SQL_NO_DATA - break!" << std::endl;
											}
										else if (rc == SQL_STILL_EXECUTING)
											{
											std::wcout << L"SQLFetch returned SQL_STILL_EXECUTING - break!" << std::endl;
											}
										else if (rc == SQL_ERROR)
											{
											std::wcout << L"SQLFetch returned SQL_ERROR - break!" << std::endl;
											}
										else if (rc == SQL_INVALID_HANDLE)
											{
											std::wcout << L"SQLFetch returned SQL_INVALID_HANDLE - break!" << std::endl;
											}
										else
											{
											std::wcout << L"SQLFetch returned unexpected rc - break!" << std::endl;
											}

										break;
										}
									count++;
									// Data type

									std::wcout << L"SQLFetch returned column " << szParameterName << std::endl;
									}

								std::wcout << L"SQLFetched " << count << L" columns" << std::endl;
								}
							}

						// Free statement handle
						SQLFreeHandle (SQL_HANDLE_STMT, hStmt);
						}

					// Disconnect from data source
					SQLDisconnect (hDbc);
					}

				// Free connection handle
				SQLFreeHandle (SQL_HANDLE_DBC, hDbc);
				}			
			}
		// Free environment handle
		SQLFreeEnv (hEnv);
		}
	}

